// GLUT key handling code

#include "key.h"
#include "view.h"
#include "draw.h"
#include "pngtex.h"

#include <GL/glut.h>
#include <stdio.h>
#include <stdlib.h>

// called on any keypress
// 
// We don't use x and y, but they're the mouse location when the key
// was pressed.
extern "C" void
key(unsigned char k, int /*x*/, int /*y*/)
{
    char *image;
    FILE *ifile;

    switch (k) {
    case 'T': case 't': {	// t: switch to teapot
	glutDisplayFunc(drawTeapot);
	glutPostRedisplay();
	break;
    }
    case 's': case 'S': {	// s: switch to sphere
	glutDisplayFunc(drawSphere);
	glutPostRedisplay();
	break;
    }
    case 'd': case 'D': {	// d: switch to torus (donut)
	glutDisplayFunc(drawDonut);
	glutPostRedisplay();
	break;
    }
    case 'p': case 'P': {	// p: switch to plane
	glutDisplayFunc(drawPlane);
	glutPostRedisplay();
	break;
    }
    case 'i': case 'I': {	// i: dump image
	dumpPNG("dump.png",0,0,winWidth,winHeight);
	break;
    }
    case 'v': case 'V': {	// v: update vertex shader
	updateShaders(0);
	break;
    }
    case 'f': case 'F': {	// f: update fragment shader
	updateShaders(0);
	break;
    }
    case '0': case '1': case '2': case '3': case '4':
    case '5': case '6': case '7': case '8': case '9': {
	// numbers adjust frame counters (see draw.h for mapping)
	updateFrame(k-'0');
	break;
    }
    case 27: {			// Escape: exit
	exit(0);
    }
    }
}
